//==============================================================
// O[oϐ
float4x4 mW;		// [hs
float4x4 mP;		// ˉes
float4x4 mWV;		// [hr[
float4x4 mWVP;		// [hr[ˉe

float4 Diffuse;		// Cgƃ}eA̐F
float4 Specular;	// Cgƃ}eÃXyL
float4 Ambient;		// Cgƃ}eA
float Power;		// }eÃXyL̗
texture MeshTex;	// }eÃeNX`
float3 LightDir;	// Cg̕

float3 Eyepos;		// _̈ʒu

float2   vFog;		// (Far/(Far-Near), -1/(Far-Near))

int NoTexFlag=0;

//==============================================================
// eNX`Tv
//	EgpeNX`̃TvXe[gݒ
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

//==============================================================
// ʏ`
//==============================================================
// _VF[_sNZVF[_ɓnf[^p\
struct VS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Col		: COLOR0;
	float4 Spe		: COLOR1;
	float2 MeshUV	: TEXCOORD0;
	float Fog		: FOG;
};

// _VF[_
//	E_PĂ̂ŁAsNZVF[_ɓnB
VS_OUTPUT VS (
	float4 pos : POSITION,
	float3 normal : NORMAL,
	float2 mesh_uv : TEXCOORD0
) {
	VS_OUTPUT Out = (VS_OUTPUT)0;		// sNZf[^ɓnf[^p\
	
	// _WAeNX`W
	Out.Pos = mul(pos, mWVP);
	Out.MeshUV = mesh_uv;


	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)mW));
	Out.Col = Ambient + Diffuse*max(0, dot(-LightDir,w_normal));
	Out.Col.a = Diffuse.a;
	
	// XyL
	float3 Eye = normalize( Eyepos - mul( pos, mW ) );
	float3 r = -Eye + 2.0f * dot( w_normal, Eye ) * w_normal;
	Out.Spe = Specular * pow(max(0,dot(-LightDir,r)),Power);
	
		
	Out.Fog = vFog.x + Out.Pos.w * vFog.y;

	return Out;
}

// sNZVF[_
//	EsNZ̐F肵A̐FԂ(R,G,B,Afloat4^)
float4 PS(VS_OUTPUT In) : COLOR {
	// eNX`Fƒ_F̍
	return tex2D(MeshSmp, In.MeshUV) * In.Col + In.Spe;
}

float4 NoTexPS(VS_OUTPUT In) : COLOR {
	// eNX`Fƒ_F̍
	return In.Col + In.Spe;
}


//==============================================================
// eNjbN

PixelShader PSArray[2] = { compile ps_2_0 PS(),
							compile ps_2_0 NoTexPS()
							};

technique Basic {
	pass P0 {
		VertexShader=compile vs_1_1 VS();
		PixelShader=(PSArray[NoTexFlag]);
	}
}
