//==============================================================
// O[oϐ
float4x4 mW;		// [hs
float4x4 mP;		// ˉes
float4x4 mWV;		// [hr[
float4x4 mWVP;		// [hr[ˉe

float4 Diffuse;		// Cgƃ}eA̐F
float4 Specular;	// Cgƃ}eÃXyL
float4 Ambient;		// Cgƃ}eA
float Power;		// }eÃXyL̗
texture MeshTex;	// }eÃeNX`
float3 LightDir;	// Cg̕

float3 Eyepos;		// _̈ʒu

texture InputTex;
texture BloomTex;
float2 SampleOffset[3];
float SampleWeight[3];

float4   vFog;		// (Far/(Far-Near), -1/(Far-Near))

//==============================================================
// eNX`Tv
//	EgpeNX`̃TvXe[gݒ
sampler MeshSmp=sampler_state {
	Texture=<MeshTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU = Wrap;
	AddressV = Wrap;
};

sampler InputSmp=sampler_state {
	Texture=<InputTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=BORDER;
	AddressV=BORDER;
};
// u[p
sampler BloomSmp=sampler_state {
	Texture=<BloomTex>;
	MipFilter=LINEAR;
	MinFilter=LINEAR;
	MagFilter=LINEAR;
	AddressU=BORDER;
	AddressV=BORDER;
};

//==============================================================
// u[VF[_
float4 BloomPS(
	float2 UV : TEXCOORD0
) : COLOR {
	float3 color=0;

	color+=tex2D(InputSmp, UV+SampleOffset[0])*SampleWeight[0];
	color+=tex2D(InputSmp, UV+SampleOffset[1])*SampleWeight[1];
	color+=tex2D(InputSmp, UV+SampleOffset[2])*SampleWeight[2];

	return float4(color, 1);
}

// _VF[_
struct SPECVS_OUTPUT
{
	float4 Pos		: POSITION;
	float4 Spe		: COLOR1;
};
SPECVS_OUTPUT SpecHDRVS (
	float4 pos : POSITION,
	float3 normal : NORMAL
) {
	SPECVS_OUTPUT Out = (SPECVS_OUTPUT)0;		// sNZf[^ɓnf[^p\
	
	// _WAeNX`W
	Out.Pos = mul(pos, mWVP);


	// _F
	float3 w_normal=normalize(mul(normal, (float3x3)mW));

	// XyL
	float3 Eye = normalize( Eyepos - mul( pos, mW ) );
	float3 r = -Eye + 2.0f * dot( w_normal, Eye ) * w_normal;
	Out.Spe = Specular * pow(max(0,dot(-LightDir,r)),Power);
	Out.Spe.a = 1;
		
	return Out;
}

// sNZVF[_
float4 SpecHDRPS(SPECVS_OUTPUT In) : COLOR {

	// eNX`Fƒ_F̍
	return In.Spe;
}


//==============================================================
// eNjbN
technique SpecluarOnly {
	pass P0 {
		FogEnable=false;
		VertexShader=compile vs_1_1 SpecHDRVS();
		PixelShader=compile ps_2_0 SpecHDRPS();
	}
}

technique Bloom {
	pass P0 {
		FogEnable=false;
		PixelShader=compile ps_2_0 BloomPS();
	}
}
